>Link
luogu P8844
>Description
>解题思路
因为每次操作一都会将之前的操作全部覆盖,所以这道题就简单了很多。
我们在每个点建一个权值线段树,下标为深度,在这个点深度处 + 1 +1 +1,从下至上合并线段树就变成了整棵子树的信息,每次操作二的时候直接输出 x x x 线段树中 [ x , n ] [x,n] [x,n] 的总数就可以了。
注意线段树合并必须离线处理。
>代码
#include <iostream>
#include <cstdio>
#include <cstring>
#include <algorithm>
#include <vector>
#define N 100010
#define M 8000010
#define P pair<int, int>
#define MP make_pair
#define fi first
#define se second
using namespace std;
vector<P> q[N];
struct edge
{
int to, nxt;
} e[N * 2];
int n, m, cnt, h[N], dep[N], root[N], ls[M], rs[M], val[M], tot, ans[N];
void add (int u, int v)
{
e[++cnt] = (edge